"""
Django settings for ambition_dashboard project.

Generated by 'django-admin startproject' using Django 1.11.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os
import sys

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
APP_NAME = "ambition_dashboard"
ETC_DIR = BASE_DIR
# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = "ftblcrb__%!_r6nl_kn-*u(rwhfeakwv*)j4^%=ltvp&s9^@i9"

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True
SITE_ID = 10
REVIEWER_SITE_ID = 0


ALLOWED_HOSTS = []

# Application definition

INSTALLED_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.messages",
    "django.contrib.sessions",
    "django.contrib.sites",
    "django.contrib.staticfiles",
    "django_crypto_fields.apps.AppConfig",
    "django_revision.apps.AppConfig",
    "edc_reference.apps.AppConfig",
    "edc_action_item.apps.AppConfig",
    "edc_auth.apps.AppConfig",
    "edc_base.apps.AppConfig",
    "edc_consent.apps.AppConfig",
    "edc_dashboard.apps.AppConfig",
    "edc_device.apps.AppConfig",
    "edc_lab.apps.AppConfig",
    "edc_lab_dashboard.apps.AppConfig",
    "edc_locator.apps.AppConfig",
    "edc_metadata_rules.apps.AppConfig",
    "edc_model_wrapper.apps.AppConfig",
    "edc_navbar.apps.AppConfig",
    "edc_notification.apps.AppConfig",
    "edc_offstudy.apps.AppConfig",
    "edc_pharmacy.apps.AppConfig",
    "edc_pharmacy_dashboard.apps.AppConfig",
    "edc_registration.apps.AppConfig",
    "edc_subject_dashboard.apps.AppConfig",
    "edc_timepoint.apps.AppConfig",
    "edc_visit_schedule.apps.AppConfig",
    "ambition_ae.apps.AppConfig",
    "ambition_labs.apps.AppConfig",
    "ambition_lists.apps.AppConfig",
    "ambition_prn.apps.AppConfig",
    "ambition_rando.apps.AppConfig",
    "ambition_reference.apps.AppConfig",
    "ambition_screening.apps.AppConfig",
    "ambition_subject.apps.AppConfig",
    "ambition_visit_schedule.apps.AppConfig",
    "ambition_dashboard.apps.EdcProtocolAppConfig",
    "ambition_dashboard.apps.EdcAppointmentAppConfig",
    "ambition_dashboard.apps.EdcFacilityAppConfig",
    "ambition_dashboard.apps.EdcIdentifierAppConfig",
    "ambition_dashboard.apps.EdcMetadataAppConfig",
    "ambition_dashboard.apps.EdcVisitTrackingAppConfig",
    "ambition_dashboard.apps.AppConfig",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.contrib.sites.middleware.CurrentSiteMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "edc_subject_dashboard.middleware.DashboardMiddleware",
    "edc_dashboard.middleware.DashboardMiddleware",
    "edc_lab_dashboard.middleware.DashboardMiddleware",
]


ROOT_URLCONF = "ambition_dashboard.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ]
        },
    }
]

WSGI_APPLICATION = "ambition_dashboard.wsgi.application"


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.sqlite3",
        "NAME": os.path.join(BASE_DIR, "db.sqlite3"),
    }
}


# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator"
    },
    {"NAME": "django.contrib.auth.password_validation.MinimumLengthValidator"},
    {"NAME": "django.contrib.auth.password_validation.CommonPasswordValidator"},
    {"NAME": "django.contrib.auth.password_validation.NumericPasswordValidator"},
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

RANDOMIZATION_LIST_PATH = os.path.join(
    BASE_DIR, APP_NAME, "tests", "test_randomization_list.csv"
)
STATIC_URL = "/static/"
KEY_PATH = os.path.join(BASE_DIR, "crypto_fields")
COUNTRY = "botswana"
HOLIDAY_FILE = os.path.join(BASE_DIR, APP_NAME, "tests", "holidays.csv")
GIT_DIR = BASE_DIR
LOGIN_REDIRECT_URL = "home_url"

DASHBOARD_URL_NAMES = {
    "subject_models_ur": "subject_models_url",
    "subject_listboard_url": "ambition_dashboard:subject_listboard_url",
    "screening_listboard_url": "ambition_dashboard:screening_listboard_url",
    "subject_dashboard_url": "ambition_dashboard:subject_dashboard_url",
    "tmg_summary_listboard_url": "ambition_dashboard:tmg_summary_listboard_url",
    "tmg_ae_listboard_url": "ambition_dashboard:tmg_ae_listboard_url",
    "tmg_death_listboard_url": "ambition_dashboard:tmg_death_listboard_url",
    "subject_review_listboard_url": "ambition_dashboard:subject_review_listboard_url",
}

DASHBOARD_BASE_TEMPLATES = {
    "edc_base_template": "edc_dashboard/base.html",
    "listboard_base_template": "ambition_edc/base.html",
    "dashboard_base_template": "ambition_edc/base.html",
    "screening_listboard_template": "ambition_dashboard/screening/listboard.html",
    "subject_listboard_template": "ambition_dashboard/subject/listboard.html",
    "subject_dashboard_template": "ambition_dashboard/subject/dashboard.html",
    "tmg_ae_listboard_template": "ambition_dashboard/tmg/ae_listboard.html",
    "tmg_death_listboard_template": "ambition_dashboard/tmg/death_listboard.html",
    "tmg_summary_listboard_template": "ambition_dashboard/tmg/summary_listboard.html",
    "subject_review_listboard_template": "edc_subject_dashboard/subject_review_listboard.html",
}

LAB_DASHBOARD_REQUISITION_MODEL = "ambition_subject.subjectrequisition"

EDC_BOOTSTRAP = 3
EMAIL_CONTACTS = {
    "data_request": "someone@example.com",
    "data_manager": "someone@example.com",
    "tmg": "someone@example.com",
}
EMAIL_ENABLED = False
TWILIO_ENABLED = False

if "test" in sys.argv:

    class DisableMigrations:
        def __contains__(self, item):
            return True

        def __getitem__(self, item):
            return None

    MIGRATION_MODULES = DisableMigrations()
    PASSWORD_HASHERS = ("django.contrib.auth.hashers.MD5PasswordHasher",)
    DEFAULT_FILE_STORAGE = "inmemorystorage.InMemoryStorage"
